<?php
/**
 * Created by PhpStorm.
 * User: michael
 * Date: 12/11/2015
 * Time: 4:23 PM
 */

class WPSG_SettingsController {
	private $wpsg = null;


	public function __construct($wpsg) {
		$this->wpsg = $wpsg;
	}

	public function handle_actions() {

		if (!current_user_can('manage_options'))
			return;

		if (isset($_POST['action'])
				&& isset($_POST['option_page'])
				&& $_POST['action'] == 'update'
				&& $_GET['page'] == WPSG_SLUG
		) {
			$nonce = $_POST['_wpnonce'];
			$tab   = $_POST['tab'];

			if ($tab == 'configuration')
				$nonce_name = 'wpsg_configuration-options';
			else if ($tab == 'advanced')
				$nonce_name = 'wpsg_advanced-options';
			else if ($tab == 'exceptions')
				$nonce_name = 'wpsg_exceptions-options';
			else
				return;

			if (wp_verify_nonce($nonce, $nonce_name)) {
				if( $tab == 'configuration' ) {

					if( $this->wpsg->get_option('mode') != $_POST['mode'] ){
						require_once WPSG_CONTROLLER_DIR . '/WPSG_WhitelistController.php';
						require_once WPSG_CONTROLLER_DIR . '/WPSG_BlockedIPController.php';
						$whitelist = new WPSG_WhitelistController($this->wpsg);
						$blocklist = new WPSG_BlockedIPController($this->wpsg);

						$whitelist->delete_all();
						$whitelist->add($this->wpsg->get_current_ip());
						$blocklist->delete_all();
					}

					$this->wpsg->set_option('mode', $_POST['mode']);
					$this->wpsg->set_option('admin_enabled', isset($_POST['admin_enabled']));
					$this->wpsg->set_option('learning_mode', isset($_POST['learning_mode']));

					$this->wpsg->set_option('blocked_message', stripslashes($_POST['blocked_message']));
					$this->wpsg->set_option('banned_message', stripslashes($_POST['banned_message']));

					$this->wpsg->get_licensing()->set_license(stripslashes($_POST['license_key']));

					if ($this->wpsg->get_licensing()->has_changed()) {
						echo '<script>location.reload();</script>';
						exit;
					}
				}
				if( $tab == 'advanced' ) {
					$this->wpsg->set_option('vulnerability_scanner_enabled', isset($_POST['vulnerability_scanner_enabled']));
					$this->wpsg->set_option('blacklist_enabled', isset($_POST['blacklist_enabled']));

					$this->wpsg->set_option('admin_enabled', isset($_POST['admin_enabled']));
					$this->wpsg->set_option('learning_mode', isset($_POST['learning_mode']));

					$this->wpsg->set_option('block_threshold', $_POST['block_threshold']);
					$this->wpsg->set_option('notify_threshold', $_POST['notify_threshold']);
					$this->wpsg->set_option('ban_threshold_total', $_POST['ban_threshold_total']);
					$this->wpsg->set_option('ban_threshold_time', $_POST['ban_threshold_time']);
				}
				if( $tab == 'exceptions' ){
					$this->wpsg->set_option('exception_get', stripslashes($_POST['exception_get']));
					$this->wpsg->set_option('exception_post', stripslashes($_POST['exception_post']));
					$this->wpsg->set_option('exception_cookie', stripslashes($_POST['exception_cookie']));
					$this->wpsg->set_option('exception_server', stripslashes($_POST['exception_server']));
				}

			} else {
				die('Bad Nonce');
			}
		}
	}
	public function render(){
		require_once WPSG_VIEW_DIR . '/WPSG_SettingsView.php';
		$view = new WPSG_SettingsView($this->wpsg);
		$view->render();
	}
}