<?php
/**
 * Created by PhpStorm.
 * User: michael
 * Date: 12/11/2015
 * Time: 3:30 PM
 */

if( ! class_exists('Metatick_WPSettingsHelper_1_0')) {
	class Metatick_WPSettingsHelper_1_0 {
		public static function render_textbox($args) {
			$name        = $args['name'];
			$id          = $args['id'];
			$description = $args['description'];
			$value       = $args['value'];

			$value = htmlspecialchars($value,ENT_QUOTES);


			echo "<input type='text' class='text' id='$id' name='$name' value=\"$value\"/>";
			echo '<p class="description">';
			echo $description;
			echo '</p>';
		}

		public static function render_textarea($args) {
			$name        = $args['name'];
			$id          = $args['id'];
			$description = $args['description'];
			$value       = $args['value'];
			$width       = $args['width'];
			$height       = $args['height'];

			$value = htmlspecialchars($value,ENT_QUOTES);

			$style = '';
			if( !empty($width) )
				$style .= "width:$width;";

			if( !empty($height) )
				$style .= "height:$height;";

			if( !empty($style) )
				$style = "style='$style'";

			echo '<p>';
			echo "<textarea id='$id' name='$name' $style>";
			echo $value;
			echo '</textarea>';
			echo "<label for='$id'>$description</label>";
			echo '</p>';
		}

		public static function render_checkbox($args) {
			$name        = $args['name'];
			$id          = $args['id'];
			$description = $args['description'];
			$value       = $args['value'];
			$checked     = checked($value, true, false);

			echo '<p>';
			echo "<input type='checkbox' class='checkbox' id='$id' name='$name' value='1' $checked />";
			echo "<label for='$id'>$description</label>";
			echo '</p>';
		}

		public static function render_radio($args) {
			$name    = $args['name'];
			$value   = $args['value'];
			$options = $args['options'];

			foreach ($options as $key => $description) {
				$id      = "{$name}_{$key}";
				$checked = checked($value, $key, false);

				echo '<p>';
				echo "<input type='radio' class='radio' id='$id' name='$name' value='$key' $checked />";
				echo "<label for='$id'>$description</label>";
				echo '</p>';
			}
		}

		public static function render_select($args) {
			$name        = $args['name'];
			$id          = $args['id'];
			$description = $args['description'];
			$current     = $args['value'];
			$options     = $args['options'];

			echo '<p>';
			echo "<select name='$name' id='$id'>";

			foreach ($options as $value => $name) {
				$selected = selected($value, $current, false);
				echo "<option value='$value' $selected>$name</option>";
			}
			echo '</select>';
			echo "<label for='$id'>$description</label>";
			echo '</p>';
		}

		public static function render_image_browser($args) {
			$name    = $args['name'];
			$id    = $args['name'];
			$value   = $args['value'];
			$description = $args['description'];
			echo '<p>';
			echo "<input type='text' id='$id' name='$name' placeholder='enter an image url' value='$value'/><a class='button' id='$id-button'>Browse</a><br />";
			echo "<label for='$id'>$description</label>";
			echo '</p>';
			echo '<script>';
			echo "jQuery(function(){";
				echo "jQuery('#$id-button').click(function(){";
					echo "window.mb = window.mb || {};";
					echo "window.mb.frame = wp.media();";
					echo "window.mb.frame.on( 'select', function() {";
						echo "var json = window.mb.frame.state().get('selection').first().toJSON();";
						echo "if (0 > jQuery.trim(json.url.length)) {";
							echo "return;";
						echo "}";
						echo "jQuery('#$id').val(json.url);";
						echo "jQuery('#$id').change();";
					echo "});";
					echo "window.mb.frame.state('embed').on( 'select', function() {";
						echo "var json = window.mb.frame.state().props.toJSON();";
						echo "if (0 > jQuery.trim(json.url.length)) {";
							echo "return;";
						echo "}";
						echo "jQuery('#$id').val(json.url);";
						echo "jQuery('#$id').change();";
					echo "});";
					echo "window.mb.frame.open();";
					echo "return false;";
				echo "});";
			echo "});";
			echo '</script>';
		}

		public static function render_custom($args){
			$id    = $args['id'];
			$custom    = $args['custom'];

			$description = $args['description'];
			echo '<p>';
			echo $custom;
			echo "<label for='$id'>$description</label>";
			echo '</p>';
		}

		public static function render_section($args) {

		}
	}
}