<?php
/**
 * Created by PhpStorm.
 * User: michael
 * Date: 12/11/2015
 * Time: 3:30 PM
 */

if( ! class_exists('Metatick_WPTabbedSettingsPage_1_0')) {
	class Metatick_WPTabbedSettingsPage_1_0 {
		private $tabs = array();
		private $title = "";
		private $default = false;

		function __construct($title, $default = false) {
			$this->title   = $title;
			$this->default = $default;
		}

		function add_tab($slug, $title, $callback) {
			if (empty($this->default)) {
				$this->default = $slug;
			}
			$this->tabs[$slug]             = array();
			$this->tabs[$slug]['title']    = $title;
			$this->tabs[$slug]['callback'] = $callback;
		}

		function render($render_page) {
			$page     = $_GET['page'];
			$selected = '';
			if (isset($_GET['tab']))
				$selected = $_GET['tab'];

			if (empty($selected))
				$selected = $this->default;

			echo '<div class="wrap">';
			echo "<h1>{$this->title}</h1>";
			echo '<div id="icon-themes" class="icon32"><br></div>';
			echo '<h2 class="nav-tab-wrapper">';
			foreach ($this->tabs as $slug => $tab) {
				$classes = 'nav-tab';
				if ($slug == $selected)
					$classes .= ' nav-tab-active';

				echo "<a class='{$classes}' href='?page={$page}&tab={$slug}'>{$tab['title']}</a>";
			}
			echo '</h2>';

			$nonce = call_user_func($this->tabs[$selected]['callback']);

			if( $nonce != false ) {
				echo '<form method="post">';
				echo "<input type='hidden' name='tab' value='$selected'>";
				do_settings_sections($render_page);
				settings_fields($nonce);
				submit_button();
				echo '</form>';
			}

			echo '</div>';
		}
	}
}