<?php
/**
 * Created by PhpStorm.
 * User: michael
 * Date: 24/11/2015
 * Time: 1:20 PM
 */

require_once WPSG_INCLUDE_DIR . '/WPSG_Database.php';

class WPSG_Blacklist {

	protected $wpsg = null;

	public function __construct($wpsg){
		$this->wpsg = $wpsg;
		if ($this->wpsg->get_licensing()->is_licensed()) {
			if ($this->wpsg->get_licensing()->has_feature('professional')) {
				if (!wp_next_scheduled(WPSG_SLUG . '_blacklist_update')) {
					wp_schedule_event(time(), 'hourly', WPSG_SLUG . '_blacklist_update');
				}
				add_action(WPSG_SLUG . '_blacklist_update', array($this, 'update'));
			}
		}
	}

	public function is_blocked($ip){
		global $wpdb;
		$table_name = WPSG_Database::get_blacklist_table_name();

		$count = $wpdb->get_var(
			$wpdb->prepare(	"
				SELECT count(ip)
				FROM $table_name
				WHERE ip = %s
				",
				$ip
			)
		);

		return ! ($count == null || $count == 0);
	}

	public function update(){
		try{
			$url = 'http://myip.ms/files/blacklist/htaccess/latest_blacklist.txt';
			$response = wp_remote_get($url);
			$body = wp_remote_retrieve_body( $response );

			$body = str_replace( array( "\r\n", "\r" ), "\n", $body);
			$lines = explode( "\n", $body );
			$ips = array();
			foreach ( $lines as $line ) {
				if( preg_match(
					"/^deny from [0-9]*\\.[0-9]*\\.[0-9]*\\.[0-9]*$/",
					$line) != 1
					)
					continue;

				$ip = substr($line,strlen("deny from "));
				$ips[] = $ip;
			}

			if( count($ips) > 0 ){
				global $wpdb;
				$sql = 'DELETE FROM ' . WPSG_Database::get_blacklist_table_name();
				$wpdb->query( $sql );


				foreach( $ips as $ip ){
					$wpdb->insert(
						WPSG_Database::get_blacklist_table_name(),
						array(
							'ip' => $ip,
						)
					);
				}
			}
		}catch (Exception $ex){

		}
	}
}
