<?php
/**
 * Created by PhpStorm.
 * User: michael
 * Date: 24/11/2015
 * Time: 5:22 PM
 */

class WPSG_ThreatLogTable extends WP_List_Table {

	protected $wpsg = null;
	function __construct($wpsg,$items,$total,$per_page) {
		parent::__construct( array(
			'singular'=> 'log', //Singular label
			'plural' => 'logs', //plural label, also this well be one of the table css class
			'ajax'   => false //We won't support Ajax for this table
		) );

		$this->wpsg = $wpsg;
		$this->items = $items;
		$this->set_pagination_args( array(
				"total_items" => $total,
				"total_pages" => ceil($total/$per_page),
				"per_page" => $per_page,
		) );
		$this->_column_headers=array($this->get_columns(), array(), $this->get_sortable_columns());
	}

	function get_columns() {
		return $columns= array(
			'cb'      => __('<input type="checkbox" />'),
			'date'=>__('Date'),
			'ip'=>__('IP'),
			'name'=>__('Parameter'),
			'url'=>__('Url'),
			'tags'=>__('Attack Vectors'),
		);
	}

	public function get_sortable_columns() {
		return $sortable = array(
			'date'  =>  array('date',false),
			'ip'  =>  array('ip',false),
			'name'  =>  array('name',false),
			'url'   =>  array('url',false)
		);
	}

	function get_bulk_actions() {
		return array(
				'delete' => 'Delete',
				'except' => 'Add Exception'
		);
	}

	function column_cb($item) {
		return sprintf(
				'<input type="checkbox" name="id[]" value="%s" />', $item->id
		);
	}

	function column_date($item) {
		$html = $item->date . $this->row_actions(
				array(
						'delete' => "<a href='#' onclick='wpsg_delete({$item->id})'>Delete</a>",
						'except' => "<a href='#' onclick='wpsg_except({$item->id})'>Add Exception</a>"
				)
		);
		$html .= "<div id='log-{$item->id}' style='display:none;'>";
		$html .= '<p>';
		$html .= '<textarea style="width:100%;height:350px">';
		$html .= json_encode($item,JSON_PRETTY_PRINT);
		$html .= '</textarea>';
		$html .= '</p>';
		$html .= '</div>';

		$html .= "<a href='#TB_inline?width=600&height=400&inlineId=log-{$item->id}' class='thickbox'>View Details</a>";

		return $html;
	}

	function column_ip($item) {
		return htmlentities($item->ip);
	}

	function column_name($item) {
		return htmlentities($item->name);
	}

	function column_url($item) {
		return htmlentities($item->url);
	}

	function column_tags($item) {
		return $this->wpsg->format_tags($item->tags);
	}

	function display(){
		echo '<form method="post" id="wpsg_log_actions">';
		$this->search_box( 'search', 'search_id' );
		parent::display();
		echo '</form>';
	}
}