<?php
/**
 * Created by PhpStorm.
 * User: michael
 * Date: 24/11/2015
 * Time: 5:22 PM
 */

class WPSG_WhitelistTable extends WP_List_Table {

	protected $wpsg = null;
	function __construct($wpsg,$items,$total,$per_page) {
		parent::__construct( array(
				'singular'=> 'whitelist', //Singular label
				'plural' => 'whitelists', //plural label, also this well be one of the table css class
				'ajax'   => false //We won't support Ajax for this table
		) );

		$this->wpsg = $wpsg;
		$this->items = $items;
		$this->set_pagination_args( array(
				"total_items" => $total,
				"total_pages" => ceil($total/$per_page),
				"per_page" => $per_page,
		) );
		$this->_column_headers=array($this->get_columns(), array(), $this->get_sortable_columns());
	}

	function get_columns() {
		return $columns= array(
				'cb'      => __('<input type="checkbox" />'),
				'ip'=>__('IP'),
		);
	}

	public function get_sortable_columns() {
		return $sortable = array(
				'ip'  =>  array('ip',false),
		);
	}

	function get_bulk_actions() {
		return array(
				'delete' => 'Delete'
		);
	}

	function column_cb($item) {
		return sprintf(
				'<input type="checkbox" name="id[]" value="%s" />', $item->id
		);
	}

	function column_ip($item) {
		return $item->ip . $this->row_actions(
				array(
						'delete' => "<a href='#' onclick='wpsg_delete({$item->id})'>Delete</a>"
				)
		);
	}

	function add_box(){
		?>
		<form method="post">
		<p style="float:left;margin:0px;">
			<label class="screen-reader-text" for="search_id-search-input">add whitelisted ip:</label>
			<input type="text" name="add_whitelist_ip" value="">
			<input type="hidden" name="action" value="add">
			<input type="submit" class="button" name="add_whitelits_submit" value="Add IP Address">
			<?php wp_nonce_field('add','add-whitelist',false,true); ?>
		</p>
		</form>
		<?php
	}

	function display(){
		$this->add_box();
		echo '<form method="post" id="wpsg_whitelist_actions">';
		$this->search_box( 'search', 'search_id' );
		parent::display();
		echo '</form>';
	}
}